Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/StratAer/strataer_nuc_mod.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/StratAer/strataer_nuc_mod.F90	(revision 4727)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/StratAer/strataer_nuc_mod.F90	(revision 4727)
@@ -0,0 +1,73 @@
+! $Id: strataer_nuc_mod.F90 3930 2021-06-11 19:39:09Z oboucher $
+MODULE strataer_nuc_mod
+! This module contains information about strato microphysic model nucleation parameters
+  
+  IMPLICIT NONE
+  
+CONTAINS
+  
+  ! Init all nucleation params
+  SUBROUTINE strataer_nuc_init()
+    
+    USE ioipsl_getin_p_mod, ONLY : getin_p
+    USE print_control_mod, ONLY : lunout
+    USE mod_phys_lmdz_para, ONLY : is_master
+    USE strataer_local_var_mod, ONLY: flag_nuc_rate_box,nuclat_min,nuclat_max,nucpres_min,nucpres_max
+    
+    !Config Key  = flag_nuc_rate_box
+    !Config Desc = define or not a box for nucleation rate
+    ! - F = global nucleation
+    ! - T = 2D-box for nucleation need nuclat_min, nuclat_max, nucpres_min and
+    ! nucpres_max
+    !       to define its bounds.
+    !Config Def  = F
+    !Config Help = Used in physiq.F
+    !
+    CALL getin_p('flag_nuc_rate_box',flag_nuc_rate_box)
+    CALL getin_p('nuclat_min',nuclat_min)
+    CALL getin_p('nuclat_max',nuclat_max)
+    CALL getin_p('nucpres_min',nucpres_min)
+    CALL getin_p('nucpres_max',nucpres_max)
+    
+    !============= Print params =============
+    IF (is_master) THEN
+       WRITE(lunout,*) 'IN STRATAER_NUC : flag_nuc_rate_box = ',flag_nuc_rate_box
+       IF (flag_nuc_rate_box) THEN
+          WRITE(lunout,*) 'IN STRATAER_NUC : nuclat_min = ',nuclat_min,', nuclat_max = ',nuclat_max
+          WRITE(lunout,*) 'IN STRATAER_NUC : nucpres_min = ',nucpres_min,', nucpres_max = ',nucpres_max
+       ENDIF
+    ENDIF ! if master
+    
+  END SUBROUTINE strataer_nuc_init
+  
+  ! Init aerosol tracers and large scale scavinging
+  SUBROUTINE tracstrataer_init(aerosol,lessivage)
+    
+    USE infotrac_phy, ONLY: nbtr, nbtr_sulgas, id_H2SO4_strat
+    USE ioipsl, ONLY : getin
+    USE print_control_mod, ONLY : lunout
+    
+    ! Output variables
+    LOGICAL,DIMENSION(nbtr), INTENT(INOUT) :: aerosol
+    LOGICAL,INTENT(INOUT)                  :: lessivage
+    INTEGER :: it
+    
+    ! Initialization
+    lessivage  =.TRUE.
+    aerosol(:) = .FALSE.
+    
+    DO it= 1, nbtr_sulgas
+       aerosol(it)=.FALSE.
+       IF (it==id_H2SO4_strat) aerosol(it)=.TRUE.
+    ENDDO
+    DO it= nbtr_sulgas+1, nbtr
+       aerosol(it)=.TRUE.
+    ENDDO
+    
+    !!jyg(20130206) : le choix d activation du lessivage est fait dans phytrac avec iflag_lscav
+!    CALL getin('lessivage',lessivage)
+    WRITE(lunout,*) 'IN TRACSTRATAER_INIT lessivage: ',lessivage
+    
+  END SUBROUTINE tracstrataer_init
+  
+END MODULE strataer_nuc_mod
Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/StratAer/stratdistrib.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/StratAer/stratdistrib.F90	(revision 4727)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/StratAer/stratdistrib.F90	(revision 4727)
@@ -0,0 +1,68 @@
+!
+! $Id: stratemit.F90  2022-07-04 mmarchand $
+!
+SUBROUTINE STRATDISTRIB(altLMDz,altemiss,sigma_alt,f_lay_emiss)
+!
+  USE dimphy, ONLY : klon,klev
+  USE strataer_local_var_mod
+  USE YOMCST, only : RPI
+
+  IMPLICIT NONE
+
+! Input argument
+!---------------
+    REAL,DIMENSION(klev+1)  :: altLMDz    ! altitude of layer interfaces in m
+    REAL                    :: sigma_alt
+    REAL                    :: altemiss
+
+! Local variables
+!----------------
+    REAL                 :: f_lay_sum     ! sum of layer emission fractions
+    REAL                 :: alt
+    INTEGER              :: k,i_int
+    INTEGER,PARAMETER    :: n_int_alt=10  ! subintervals nb for integration over Gaussian emission
+
+! Output argument
+!----------------
+    REAL,DIMENSION(klev) :: f_lay_emiss   ! emiss fraction for every emiss for every vertical layer
+    
+    
+! Inject distrib
+!----------------
+    SELECT CASE(flag_emit_distrib)
+       
+    CASE(0) ! Gaussian distribution
+            ! Compute distribution of emission to vertical model layers
+            ! (based on Gaussian peak in altitude)
+       f_lay_sum=0.0
+       DO k=1, klev
+          f_lay_emiss(k)=0.0
+          DO i_int=1, n_int_alt
+             alt=altLMDz(k)+float(i_int)*(altLMDz(k+1)-altLMDz(k))/float(n_int_alt)
+             f_lay_emiss(k)=f_lay_emiss(k)+1./(sqrt(2.*RPI)*sigma_alt)* &
+                   & exp(-0.5*((alt-altemiss)/sigma_alt)**2.)* &           
+                   & (altLMDz(k+1)-altLMDz(k))/float(n_int_alt)
+          ENDDO
+          f_lay_sum=f_lay_sum+f_lay_emiss(k)
+        ENDDO
+        
+     CASE(1) ! Uniform distribution
+             ! In this case, parameter sigma_alt is considered
+             ! to be half the
+             ! height of the injection, centered around altemiss)
+       f_lay_sum=0.0
+       DO k=1, klev
+          f_lay_emiss(k)=max(min(altemiss+sigma_alt,altLMDz(k+1))- &
+                      & max(altemiss-sigma_alt, &
+                      & altLMDz(k)),0.)/(2.*sigma_alt)
+          f_lay_sum=f_lay_sum+f_lay_emiss(k)
+       ENDDO
+
+       END SELECT        ! End CASE over flag_emit_distrib)
+       
+       WRITE(*,*) "IN stratdistrib f_lay_emiss=",f_lay_emiss
+
+       !correct for step integration error
+       f_lay_emiss(:)=f_lay_emiss(:)/f_lay_sum
+
+END SUBROUTINE STRATDISTRIB
Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/StratAer/stratemit.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/StratAer/stratemit.F90	(revision 4727)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/StratAer/stratemit.F90	(revision 4727)
@@ -0,0 +1,162 @@
+!
+! $Id: stratemit.F90  2022-07-04 mmarchand $
+!
+SUBROUTINE STRATEMIT(pdtphys,pdt,xlat,xlon,t_seri,pplay,paprs,tr_seri,&
+                    m_emiss_vol_daily,latmin,latmax,lonmin,lonmax,altemiss,sigma_alt,id_spec,&
+                    stretchlong,ispeci,id_species_total) 
+
+  USE dimphy, ONLY : klon,klev
+  USE strataer_local_var_mod
+  USE phys_cal_mod
+  USE phys_local_var_mod, ONLY: d_q_emiss
+  USE YOMCST, only : RD, RPI, RG
+  USE geometry_mod, ONLY : cell_area, boundslat
+  USE aerophys
+  USE infotrac_phy
+  USE mod_phys_lmdz_mpi_data, ONLY :  is_mpi_root
+  USE mod_grid_phy_lmdz, ONLY: nbp_lon
+ 
+  IMPLICIT NONE
+
+! Input argument
+!---------------
+    REAL,INTENT(IN)    :: pdtphys, pdt               ! Pas d'integration pour la physique(seconde)
+    REAL,DIMENSION(klon),INTENT(IN)    :: xlat       ! latitudes pour chaque point
+    REAL,DIMENSION(klon),INTENT(IN)    :: xlon       ! longitudes pour chaque point
+    REAL,DIMENSION(klon,klev),INTENT(IN)   :: pplay
+    ! pression pour le mileu de chaque couche (en Pa)
+    REAL,DIMENSION(klon,klev+1),INTENT(IN) :: paprs
+    ! pression pour chaque inter-couche (en Pa)
+    REAL,DIMENSION(klon,klev),INTENT(IN)   :: t_seri ! Temperature
+    REAL,INTENT(IN)    :: latmin,latmax,lonmin,lonmax
+    REAL,INTENT(IN)    :: m_emiss_vol_daily          ! daily injection mass emission
+    REAL,INTENT(IN)    :: stretchlong                ! length to stretch emission (day)
+    REAL,DIMENSION(klon,klev) :: m_air_gridbox       ! mass ofair in every grid box[kg
+    REAL,INTENT(IN)     :: sigma_alt, altemiss
+    INTEGER,INTENT(IN)  :: id_spec, ispeci, id_species_total
+    
+! Output argument
+!----------------
+    REAL,DIMENSION(klon,klev,nbtr),INTENT(INOUT)  :: tr_seri ! Concentration Traceur [U/KgA]
+! Local variables
+!----------------
+    INTEGER              :: ieru, i, k, i_int, ilon, ilev
+    REAL                 :: dlat_loc
+    REAL,DIMENSION(klev+1)  :: altLMDz    ! altitude of layer interfaces in m
+    REAL                 :: zrho          ! Density of air [kg/m3]
+    REAL,DIMENSION(klev) :: zdm           ! mass of atm. model layer in kg  
+    REAL                 :: zdz           ! thickness of atm. model layer in m
+    REAL                 :: f_lay_sum     ! sum of layer emission fractions
+    REAL,DIMENSION(klev) :: f_lay_emiss   ! emiss fraction for every emiss for every vertical layer
+    REAL                 :: emission      ! emission
+    REAL                 :: theta_min, theta_max, theta ! for SAI computation between two latitudes
+    
+    IF (is_mpi_root) THEN
+       WRITE(*,*) 'IN STRATEMIT: date from phys_cal_mod=',year_cur,'-',&
+                      &  mth_cur,'-',day_cur,'-',hour,' flh2o=',flh2o
+    ENDIF
+
+!--calculate mass of air in every grid box !NL: DONE ABOVE DIRECTLY IN MAIN LOOP I,K
+!    DO ilon=1, klon
+!       DO ilev=1, klev
+!          m_air_gridbox(ilon,ilev)=(paprs(ilon,ilev)-paprs(ilon,ilev+1))/RG*cell_area(ilon)
+!       ENDDO
+!    ENDDO
+    
+    DO i=1,klon
+       
+       dlat_loc=180./RPI/2.*(boundslat(i,1)-boundslat(i,3))
+       dlon=360./2./FLOAT(nbp_lon) 
+       ! dlat = half difference of boundary latitudes
+       IF(flag_verbose_strataer) WRITE(*,*) 'IN STRATEMIT, dlat=',dlat_loc,xlat(i),xlon(i)
+       
+       theta_min = max(xlat(i)-dlat_loc,latmin)
+       theta_max = min(xlat(i)+dlat_loc,latmax)
+                
+       IF (  xlat(i).GE.latmin-dlat_loc .AND. &
+         &   xlat(i).LT.latmax+dlat_loc .AND. &
+         &   xlon(i).GE.lonmin-dlon .AND. &
+         &   xlon(i).LT.lonmax+dlon ) THEN
+                   !
+          WRITE(*,*) 'coordinates of volcanic injection point=',&
+            &    xlat(i),xlon(i),day_cur,mth_cur,year_cur
+          WRITE(*,*) 'DD m_emiss_vol_daily=', &
+            &    m_emiss_vol_daily
+          
+          !compute altLMDz
+          altLMDz(:)=0.0
+          DO k=1, klev
+             zrho=pplay(i,k)/t_seri(i,k)/RD       !air density in kg/m3
+             zdm(k)=(paprs(i,k)-paprs(i,k+1))/RG  !mass of layer in kg
+             zdz=zdm(k)/zrho                   !thickness of layer in m
+             altLMDz(k+1)=altLMDz(k)+zdz       !altitude of interface
+          ENDDO
+          
+          CALL STRATDISTRIB(altLMDz,altemiss,sigma_alt,f_lay_emiss)
+          
+          IF (flag_emit.EQ.3) then
+             theta=(sin(theta_max/180.*RPI)-sin(theta_min/180.*RPI))/ &
+               & (sin(xlat_max_sai/180.*RPI)-sin(xlat_min_sai/180.*RPI))
+          ELSE
+             theta=1.
+          ENDIF
+
+          !vertically distributed emission
+          DO k=1, klev
+            !--calculate mass of air in every grid box
+            m_air_gridbox(i,k)=(paprs(i,k)-paprs(i,k+1))/RG*cell_area(i)
+            ! stretch emission over stretchlong period
+            emission=m_emiss_vol_daily/m_air_gridbox(i,k)*f_lay_emiss(k)/stretchlong/ &
+                 &     (86400.-pdt)*theta
+            
+             IF(flag_verbose_strataer) WRITE(*,*) 'IN STRATEMIT: emission avant/apres', &
+              &  'alt= ', altLMDz(k), &
+              &  'flh2o= ',flh2o, &
+              &  'id_speac= ',id_spec,id_species_total, &
+              &  'emission= ',emission, &
+              &  'pdtphys= ',pdtphys, &
+              &  'rapport m_emiss/m_air*f_lay= ', m_emiss_vol_daily/m_air_gridbox(i,k)*f_lay_emiss(k), &
+              &   'stretchlong= ', stretchlong, &
+              &   'theta= ', theta
+             
+             IF(emission < 1.E-34) emission = 0.0
+             
+             IF (flh2o.EQ.0) THEN
+                IF(flag_verbose_strataer) WRITE(*,*) 'IN STRATEMIT: tr_ser avant/apres',&
+                  &  'i= ',i,'k= ',k, 'flh2o= ',flh2o, &
+                  &  tr_seri(i,k,id_spec), &
+                  &  tr_seri(i,k,id_spec)+emission*pdtphys
+              
+                tr_seri(i,k,id_spec)=tr_seri(i,k,id_spec)+emission*pdtphys
+                IF (id_species_total.NE.0) THEN
+                   tr_seri(i,k,id_species_total)=tr_seri(i,k,id_species_total)+emission*pdtphys
+                ENDIF
+             ELSE IF(flh2o.EQ.1) THEN
+                d_q_emiss(i,k)=emission*pdtphys
+                IF(d_q_emiss(i,k) > 1.E34) THEN
+                   WRITE(*,*) 'IN STRATEMIT: d_q_emiss(i,k) > 1.E34 = ',d_q_emiss(i,k)
+                ELSE IF(d_q_emiss(i,k) < -1.E34) THEN
+                   WRITE(*,*) 'IN STRATEMIT: d_q_emiss(i,k) < -1.E34 = ',d_q_emiss(i,k)
+                ENDIF
+                
+                IF(flag_verbose_strataer) WRITE(*,*) 'IN STRATEMIT: ',&
+                     &  'i= ',i,'k= ',k, 'flh2o= ',flh2o, &
+                     &  'emission= ',emission, &
+                     &  'd_q_emiss(i,k)= ',d_q_emiss(i,k)
+                
+                IF(d_q_emiss(i,k) > 1.E34) THEN
+                   d_q_emiss(i,k) = 1.E34
+                   WRITE(*,*) 'IN STRATEMIT: d_q_emiss(i,k) > 1.E34 : ',d_q_emiss(i,k)
+                ELSE IF(d_q_emiss(i,k) < -1.E34) THEN
+                   d_q_emiss(i,k) = -1.E34
+                   WRITE(*,*) 'IN STRATEMIT: d_q_emiss(i,k) < -1.E34 : ',d_q_emiss(i,k)
+                ENDIF
+             ENDIF
+             budg_emi(i,ispeci)=budg_emi(i,ispeci)+emission*zdm(k)
+          ENDDO
+          
+       ENDIF ! emission grid cell
+
+    ENDDO ! klon loop
+
+END SUBROUTINE STRATEMIT
